<?php
/*
 +-------------------------------------------------------------------------+
 | Copyright (C) 2006 Bradley Kite                                         |
 |                                                                         |
 | This program is free software; you can redistribute it and/or           |
 | modify it under the terms of the GNU General Public License             |
 | as published by the Free Software Foundation; either version 2          |
 | of the License, or (at your option) any later version.                  |
 |                                                                         |
 | This program is distributed in the hope that it will be useful,         |
 | but WITHOUT ANY WARRANTY; without even the implied warranty of          |
 | MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the           |
 | GNU General Public License for more details.                            |
 +-------------------------------------------------------------------------+
*/

chdir('../../');

$guest_account = true;
include("./include/auth.php");

input_validate_input_number(get_request_var("report_definition_id"));
input_validate_input_number(get_request_var("report_id"));
input_validate_input_number(get_request_var("lower_banding"));
input_validate_input_number(get_request_var("upper_banding"));
input_validate_input_number(get_request_var("result_limit"));

include_once("./include/top_graph_header.php");

show_reports();

include_once("./include/bottom_footer.php");

/* --------------------------
    Report Viewing Functions
   -------------------------- */

function show_reports()
{
    global $colors, $settings_graphs, $current_user;

    $reportDefinition = array();
    if (isset($_GET["report_definition_id"]))
    {
        $reportDefinition = db_fetch_row("SELECT
                                            id,
                                            report_name,
                                            data_template_id,
                                            graph_template_id,
                                            rra_id,
                                            include_data_from_start_hour,
                                            include_data_from_end_hour,
                                            include_data_from_start_day,
                                            include_data_from_end_day
                                          FROM
                                            plugin_cactireport_definitions
                                          WHERE
                                            id = " . $_GET["report_definition_id"]);
    }
    else
    {
        $_GET["report_definition_id"] = "";
    }

    $reportDefinitions = db_fetch_assoc("SELECT
                                           id,
                                           report_name,
                                           data_template_id,
                                           graph_template_id,
                                           rra_id,
                                           include_data_from_start_hour,
                                           include_data_from_end_hour,
                                           include_data_from_start_day,
                                           include_data_from_end_day
                                         FROM
                                           plugin_cactireport_definitions
                                         ORDER BY
                                           report_name");

    $reports = array();
    if (isset($_GET["report_definition_id"]) && $_GET["report_definition_id"] > 0)
    {
        $reports = db_fetch_assoc("SELECT
                                     id,
                                     report_definition_id,
                                     date_processed
                                   FROM
                                     plugin_cactireports
                                   WHERE
                                     report_definition_id = " . $_GET["report_definition_id"] . "
                                   ORDER BY date_processed");
    }

    $sort_method = "DESC";
    if (isset($_GET["sort_method"]) && ($_GET["sort_method"] == "DESC" || $_GET["sort_method"] == "ASC"))
    {
        $sort_method = $_GET["sort_method"];
    }

    # Which metric of the report are we goign to display?
    if ((!isset($_GET["metric"])) || $_GET["metric"] != "AVG" && $_GET["metric"] != "MIN" && $_GET["metric"] != "MAX")
    {
        $_GET["metric"] = "AVG";
    }
    $metricField = 'graph_item_avg_value';
    if ($_GET["metric"] == 'MIN')
    {
        $metricField = 'graph_item_min_value';
    }
    elseif ($_GET["metric"] == 'MAX')
    {
        $metricField = 'graph_item_max_value';
    }
    if (isset($_GET["report_id"]) && $_GET["report_id"] == -1)
    {
        $metricField = 'graph_item_last_value';
    }


    $report = array();
    $reportItems = array();
    $graphItems = array();
    if (isset($_GET["report_definition_id"]) && (!isset($_GET["report_id"])))
    {
        $_GET["report_id"] = -1;
    }
    if (isset($_GET["report_id"]) && $_GET["report_id"] > 0)
    {
        $report      = db_fetch_row("SELECT
                                       id,
                                       report_definition_id,
                                       date_processed
                                     FROM
                                       plugin_cactireports
                                     WHERE
                                       id = " . $_GET["report_id"] . "
                                     AND
                                       report_definition_id = " . $_GET["report_definition_id"]);
        if (!isset($report["id"]))
        {
            $report = getLatestReport($_GET["report_definition_id"]);
            $_GET["report_id"] = $report["id"];
        }
    }
    elseif (isset($_GET["report_id"]) && $_GET["report_id"] == -1)
    {
            $reportItems = db_fetch_assoc("SELECT
                                             plugin_cactireport_last_values.id,
                                             plugin_cactireport_last_values.local_graph_id,
                                             plugin_cactireport_items.consolidation_function_id,
                                             graph_templates_item.text_format,
                                             graph_templates_graph.vertical_label,
                                             plugin_cactireport_last_values.graph_item_last_value as graph_item_value
                                           FROM
                                             plugin_cactireport_last_values,
                                             graph_templates_item,
                                             graph_templates_graph
                                           WHERE
                                             report_definition_id = " . $_GET["report_definition_id"] . "
                                           AND
                                             plugin_cactireport_items.local_graph_id = graph_templates_item.local_graph_id
                                           AND
                                             plugin_cactireport_items.graph_item_id = graph_templates_item.id
                                           AND
                                             plugin_cactireport_items.local_graph_id = graph_templates_graph.local_graph_id
                                          ");
            $graphItems = db_fetch_assoc("SELECT DISTINCT
                                                plugin_cactireport_last_values.graph_item_id,
                                                graph_templates_item.text_format
                                              FROM
                                                plugin_cactireport_last_values,
                                                graph_templates_item
                                              WHERE
                                                graph_templates_item.id = plugin_cactireport_last_values.graph_item_id
                                              AND
                                                plugin_cactireport_last_values.report_definition_id = " . $_GET["report_definition_id"]);
    }
    else
    {
            $_GET["report_id"] = "";
    }

    if ($_GET["report_id"] > 0)
    {
            $reportItems = db_fetch_assoc("SELECT
                                             plugin_cactireport_items.id,
                                             plugin_cactireport_items.report_id,
                                             plugin_cactireport_items.local_graph_id,
                                             graph_templates_item.text_format,
                                             graph_templates_graph.vertical_label,
                                             plugin_cactireport_items.$metricField as graph_item_value
                                           FROM
                                             plugin_cactireport_items,
                                             graph_templates_item,
                                             graph_templates_graph
                                           WHERE
                                             report_id = " . $_GET["report_id"] . "
                                           AND 
                                             plugin_cactireport_items.local_graph_id = graph_templates_item.local_graph_id
                                           AND
                                             plugin_cactireport_items.graph_item_id = graph_templates_item.id
                                           AND
                                             plugin_cactireport_items.local_graph_id = graph_templates_graph.local_graph_id
                                           ");
            $graphItems = db_fetch_assoc("SELECT DISTINCT
                                                plugin_cactireport_items.graph_item_id,
                                                graph_templates_item.text_format
                                              FROM
                                                plugin_cactireport_items,
                                                graph_templates_item
                                              WHERE
                                                graph_templates_item.id = plugin_cactireport_items.graph_item_id
                                              AND
                                                plugin_cactireport_items.report_id = " . $_GET["report_id"]);
    }

    $bandings = array( 10, 20, 30, 40, 50, 60, 70, 80, 90 );
    $bandingsMultipliers = array(1, 10, 100, 1000, 10000, 100000, 1000000, 10000000, 100000000, 1000000000, 10000000000);

    if (!isset($_GET["lower_banding"]))
    {
        $_GET["lower_banding"] = 0;
    }
    if (!isset($_GET["upper_banding"]))
    {
        $_GET["upper_banding"] = 900000000000;
    }
    if ($_GET["lower_banding"] > $_GET["upper_banding"])
    {
        $_GET["lower_banding"] = 0;
        $_GET["upper_banding"] = 900000000000;
    }
    if (!isset($_GET["result_limit"]))
    {
        $_GET["result_limit"] = 0;
    }


    ?>
    <form name="report_id" method="get" action="report_view.php">
    <? html_graph_start_box(3, true); ?>
      <tr align="left">
        <td rowspan="2" align="left" valign="top">
          <span class="textHeader">Report Type</span>
          &nbsp;
          <select name="report_definition_id" onChange="this.form.submit();">
          <option value="0">Select One</option>
          <?
          foreach ($reportDefinitions as $reportDef)
          {
              print "<option value=\"" . $reportDef["id"] . "\"" . ($_GET["report_definition_id"] == $reportDef["id"] ? " selected" : "") . ">" . $reportDef["report_name"] . "</option>\n";
          }
          ?>
          </select>
          &nbsp;
          <span class="textHeader">Report Date</span>
          &nbsp;
          <select name="report_id" onChange="this.form.submit();">
            <option value="0">Select One</option>
            <?
            foreach ($reports as $report)
            {
                $endTime   = $report["date_processed"];
                $timespan  = db_fetch_cell("SELECT timespan FROM rra WHERE id = " . $reportDefinition["rra_id"]);
                $startTime = $endTime - $timespan;
                $dateRange = "";
                if (($endTime - $startTime) <= 86400)
                {
                    $dateRange = date("Y/m/d", $startTime);
                }
                else
                {
                    $dateRange = date("Y/m/d", $startTime) . " - " . date("Y/m/d", $endTime);
                }
                print "<option value=\"" . $report["id"] . "\"" . ($_GET["report_id"] == $report["id"] ? " selected" : "") . ">" . $dateRange . "</option>\n";
            }
            ?>
            <option value="-1"<? if ($_GET["report_id"] == "-1") { print " selected"; } ?>>Current Values</option>
          </select>
          &nbsp;
          <? if ($_GET["report_id"] != -1)
             {
          ?>
          <span class="textHeader">Metric</span>
          &nbsp;
          <select name="metric" onChange="this.form.submit();">
            <option value="AVG"<? if ($_GET["metric"] == "AVG") { print " selected"; } ?>>Average</option>
            <option value="MAX"<? if ($_GET["metric"] == "MAX") { print " selected"; } ?>>Maximum</option>
            <option value="MIN"<? if ($_GET["metric"] == "MIN") { print " selected"; } ?>>Minimum</option>
            <!-- I Need to think this through <option value="CUR"<? if ($_GET["metric"] == "CUR") { print " selected"; } ?>>Current</option> -->
          </select>
          &nbsp;
          <? } ?>
        </td>
      </tr>
      <tr align="left" style="text-align: left;">
        <td align="left" style="text-align: left;" valign="top">
          <span class="textHeader" align="left">Options</span><br>
        </td>
        <td valign="top">
          <table border="0" valign="top" cellpadding="0" cellspacing="0">
            <tr>
              <td valign="top">
                <span class="textHeader">Sort Order</span>
              </td>
              <td valign="top">
                <select name="sort_method">
                  <option value="ASC"<? if($sort_method == 'ASC') { print " selected";} ?>>Ascending</option>
                  <option value="DESC"<? if($sort_method == 'DESC') { print " selected";} ?>>Descending</option>
                </select>
              </td>
            </tr>
            <tr cellpadding="3" cellspacing="3">
              <td cellpadding="3" cellspacing="3">
                <span class="textHeader" title="Only show values within the given bandings">Bandings (Lower, Higher)</span>&nbsp;
              </td>
              <td>
                <select name="lower_banding">
                <?
                    print "<option value=\"0\"" . ($_GET["lower_banding"] == 0 ? ' selected' : '') . ">0</option>";
                    foreach ($bandingsMultipliers as $multiplier)
                    {
                        foreach ($bandings as $banding)
                        {
                            $value = $banding * $multiplier;
                            print "<option value=\"$value\"" . ($_GET["lower_banding"] == $value ? ' selected' : '') . ">" . displayInt($value) . "</option>";
                        }
                    }
                ?>
                </select>&nbsp;
                <select name="upper_banding">
                <?
                    print "<option value=\"0\"" . ($_GET["upper_banding"] == 0 ? ' selected' : '') . ">0</option>";
                    foreach ($bandingsMultipliers as $multiplier)
                    {
                        foreach ($bandings as $banding)
                        {
                            $value = $banding * $multiplier;
                            print "<option value=\"$value\"" . ($_GET["upper_banding"] == $value ? ' selected' : '') . ">" . displayInt($value) . "</option>";
                        }
                    }
                ?>
                </select>
              </td>
            </tr>
            <tr cellpadding="3" cellspacing="3">
              <td>
                <span class="textHeader" title="Limit Result Set">Limit Results</span>
              </td>
              <td>
                <select name="result_limit">
                  <option value="0"<? if ($_GET["result_limit"] == 0 ) { print " selected";} ?>>Show All Results</option>
                  <option value="10"<? if ($_GET["result_limit"] == 10 ) { print " selected";} ?>>10 Results</option>
                  <option value="25"<? if ($_GET["result_limit"] == 25 ) { print " selected";} ?>>25 Results</option>
                  <option value="50"<? if ($_GET["result_limit"] == 50 ) { print " selected";} ?>>50 Results</option>
                  <option value="100"<? if ($_GET["result_limit"] == 100 ) { print " selected";} ?>>100 Results</option>
                </select>
              </td>
            </tr>
          </table>
        </td>
        <td valign="top">
                <input type="image" src="../../images/button_go.gif" alt="Go" border="0" align="absmiddle" onClick="this.form.submit();">
        </td>
      </tr>
    </table>
    <?
        $graphItemResults = array();
        $graphItemMap = array();
        if (sizeof($graphItems) > 0)
        {
            foreach ($graphItems as $graphItem)
            {
                if ($_GET["report_id"] == -1)
                {
                    $results = db_fetch_assoc("SELECT
                                                 graph_templates_graph.title_cache,
                                                 plugin_cactireport_last_values.local_graph_id,
                                                 plugin_cactireport_last_values.graph_item_last_value as " . $metricField . ",
                                                 graph_templates_graph.vertical_label
                                               FROM
                                                 graph_templates_graph,
                                                 plugin_cactireport_last_values
                                               WHERE
                                                 plugin_cactireport_last_values.local_graph_id = graph_templates_graph.local_graph_id
                                               AND
                                                 plugin_cactireport_last_values.graph_item_id = " . $graphItem["graph_item_id"] . "
                                               AND
                                                 plugin_cactireport_last_values.report_definition_id = " . $_GET["report_definition_id"] . "
                                               AND
                                               (
                                                 (
                                                   plugin_cactireport_last_values.graph_item_last_value >= " . $_GET["lower_banding"] . "
                                                 AND
                                                   plugin_cactireport_last_values.graph_item_last_value <= " . $_GET["upper_banding"] . "
                                                 )
                                                 OR
                                                 (
                                                   plugin_cactireport_last_values.graph_item_last_value <= -" . $_GET["lower_banding"] . "
                                                 AND
                                                   plugin_cactireport_last_values.graph_item_last_value >= -" . $_GET["upper_banding"] . "
                                                 )
                                               )
                                               ORDER BY
                                                 plugin_cactireport_last_values.graph_item_last_value " . $sort_method);
                }
                else
                {
                    $results = db_fetch_assoc("SELECT
                                                 graph_templates_graph.title_cache,
                                                 plugin_cactireport_items.local_graph_id,
                                                 plugin_cactireport_items. " . $metricField . ",
                                                 graph_templates_graph.vertical_label
                                               FROM
                                                 graph_templates_graph,
                                                 plugin_cactireport_items
                                               WHERE
                                                 plugin_cactireport_items.local_graph_id = graph_templates_graph.local_graph_id
                                               AND
                                                 plugin_cactireport_items.graph_item_id = " . $graphItem["graph_item_id"] . "
                                               AND
                                                 plugin_cactireport_items.report_id = " . $_GET["report_id"] . "
                                               AND
                                               (
                                                 (
                                                   plugin_cactireport_items." . $metricField . " >= " . $_GET["lower_banding"] . "
                                                 AND
                                                   plugin_cactireport_items." . $metricField . " <= " . $_GET["upper_banding"] . "
                                                 )
                                                 OR
                                                 (
                                                   plugin_cactireport_items." . $metricField . " <= -" . $_GET["lower_banding"] . "
                                                 AND
                                                   plugin_cactireport_items." . $metricField . " >= -" . $_GET["upper_banding"] . "
                                                 )
                                               )
                                               ORDER BY
                                                 plugin_cactireport_items." . $metricField . " " . $sort_method);
                }

                $graphItemMap[$graphItem["graph_item_id"]] = $graphItem["text_format"];

                $graphItemResults[$graphItem["graph_item_id"]] = $results;
            }
        }
        #print_r($graphItemResults);
    ?>
    <?html_graph_start_box(1, true);?>
      <tr bgcolor='#<?php print $colors["header_panel"];?>'>
        <td>&nbsp;</td>
        <?
          
            foreach ($graphItemResults as $graphItem => $graphItemValues)
            {
                print "<td align='center' class='textHeaderDark' colspan='2'>";
                print $graphItemMap[$graphItem];
                print "</td>";
            }
        ?>
      </tr>
      <tr bgcolor='#<?php print $colors["header_panel"];?>'>
        <td>&nbsp;</td>
        <?
            foreach ($graphItemResults as $graphItem => $graphItemValues)
            {
                print "<td align='center' class='textHeaderDark' colspan='1'>";
                print "Name";
                print "</td>";
                print "<td align='center' class='textHeaderDark' colspan='1'>";
                if (isset($graphItemValues[0]))
                {
                    print $graphItemValues[0]["vertical_label"];
                }
                print "</td>";
            }
        ?>
      </tr>

      <?
        $graph_end = '';
        $graph_start = '';
        if (isset($report["date_processed"]) && isset($reportDefinition["rra_id"]))
        {
            $graph_end   = $report["date_processed"];
            $duration    = db_fetch_cell("SELECT timespan FROM rra where id = " . $reportDefinition["rra_id"]);
            $graph_start = $graph_end - $duration;
            # Adjust the start/end times according to the reportDefinition settings
            if ($duration < (60 * 60 * 24))
            {
                # Adjust the day
                $graph_start += ($reportDefinition["include_data_from_start_hour"] * 60 * 60);
                $graph_end   -= ((24 - $reportDefinition["include_data_from_end_hour"]) * 60 * 60);
            }
            elseif ($duration < (60 * 60 * 24 * 7))
            {
                # Adjust the week
                $graph_start += ($reportDefinition["include_data_from_start_day"] * 60 * 60 * 24);
                $graph_end   -= ((6 - $reportDefinition["include_data_from_end_day"]) * 60 * 60 * 24);
            }
            # Otherwise dont adjust it at all...
        }

        $thingsToPrint = 1;
        $counter = 0;
        while ($thingsToPrint == 1)
        {
            $keepPrinting = 0;
            foreach ($graphItemResults as $graphItem => $graphItemValues)
            {
                if (isset($graphItemValues[$counter + 1][$metricField]))
                {
                    $keepPrinting = 1;
                }
            }
            $thingsToPrint = $keepPrinting;
            if (($_GET["result_limit"] != 0) && ($counter >= ($_GET["result_limit"] - 1)))
            {
                $thingsToPrint = 0;
            }
            if (count($graphItemResults) > 0)
            {
                if (isset($graphItemValues[$counter]))
                {
                    form_alternate_row_color($colors["alternate"],$colors["light"],$counter);
                    print "<td class=\"textHeader\">" . ($counter + 1) . "</td>";
                    foreach ($graphItemResults as $graphItem => $graphItemValues)
                    {
                        print "<td>";
                        if ($_GET["report_id"] == -1)
                        {
                            print "<a href=\"../../graph.php?action=zoom&local_graph_id=" . $graphItemValues[$counter]["local_graph_id"] . "&view_type=&rra_id=" . $reportDefinition["rra_id"] . "\">" . $graphItemValues[$counter]["title_cache"] . "</a>";
                        }
                        else
                        {
                            print "<a href=\"../../graph.php?action=zoom&local_graph_id=" . $graphItemValues[$counter]["local_graph_id"] . "&view_type=&graph_start=" . $graph_start . "&graph_end=" . $graph_end . "&rra_id=" . $reportDefinition["rra_id"] . "\">" . $graphItemValues[$counter]["title_cache"] . "</a>";
                        }
                        print "</td>";
                        print "<td>";
                        print displayFloat($graphItemValues[$counter][$metricField]);
                        print "</td>";
                    }
                }
                print "</tr>\n";
            }
            else
            {
                print "<tr><td align=\"center\" class=\"textHeader\">There are no results in this report.</td></tr>";
            }
            $counter++;
        }
      ?>
        </td>
      </tr>
    </table>
    
    </form>

        <?

    include("./include/bottom_footer.php");
}

function displayFloat($value)
{
    if (!isset($value))
    {
        return '';
    }
    $isNegative = 0;
    if ($value < 0)
    {
        $isNegative = 1;
        $value = $value * -1;
    }
    $suffix = "";
    if ($value > 1000000000)
    {
        $value = $value / 1000000000;
        $suffix = "G";
    }
    elseif ($value > 1000000)
    {
        $value = $value / 1000000;
        $suffix = "M";
    }
    elseif ($value > 1000)
    {
        $value = $value / 1000;
        $suffix = "K";
    }
    if ($isNegative == 1)
    {
        $value = -$value;
    }
    return sprintf("%0.2f %s", $value, $suffix);
}

function displayInt($value)
{
    if (!isset($value))
    {
        return '';
    }
    $isNegative = 0;
    if ($value < 0)
    {
        $isNegative = 1;
        $value = $value * -1;
    }
    $suffix = "";
    if ($value > 1000000000)
    {
        $value = $value / 1000000000;
        $suffix = "G";
    }
    elseif ($value > 1000000)
    {
        $value = $value / 1000000;
        $suffix = "M";
    }
    elseif ($value > 1000)
    {
        $value = $value / 1000;
        $suffix = "K";
    }
    if ($isNegative == 1)
    {
        $value = -$value;
    }
    return sprintf("%d %s", $value, $suffix);
}

function getLatestReport($report_definition_id)
{
    if (isset($report_definition_id) && $report_definition_id > 0)
    {
        $report = db_fetch_row("SELECT
                                  id,
                                  report_definition_id,
                                  date_processed
                                FROM
                                  plugin_cactireports
                                WHERE
                                  report_definition_id = " . $report_definition_id . "
                                ORDER BY
                                  date_processed DESC
                                LIMIT 1");
        return $report;
    }
}

?>
