<?php
/*******************************************************************************

    Author ......... Bradley Kite
    Contact ........ bradley@kitefamily.co.uk
    Home Site ...... http://www.kitefamily.co.uk
    Program ........ Reports for Cacti
    Version ........ 0.0.1

*******************************************************************************/

function plugin_init_cactireports() {
        global $plugin_hooks;

        $plugin_hooks['config_arrays']['cactireports']         = 'cactireports_config_arrays';
        $plugin_hooks['config_form']['cactireports']           = 'cactireports_config_form';
        $plugin_hooks['top_header_tabs']['cactireports']       = 'cactireports_show_tab';
        $plugin_hooks['top_graph_header_tabs']['cactireports'] = 'cactireports_show_tab';
        $plugin_hooks['draw_navigation_text']['cactireports']  = 'cactireports_draw_navigation_text';
        $plugin_hooks['poller_bottom']['cactireports']         = 'cactireports_update_current_values';
}

function cactireports_draw_navigation_text($nav)
{
    $nav["report_view.php:"]                = array("title" => "Reports", "mapping" => "", "url" => "report_view.php", "level" => "1");
    $nav["report_settings.php:"]            = array("title" => "Report Settings", "mapping" => "index.php:", "url" => "report_settings.php", "level" => "1");
    $nav["report_settings.php:report_edit"] = array("title" => "Report Settings", "mapping" => "index.php:", "url" => "report_settings.php", "level" => "1");
    $nav["report_settings.php:actions"]     = array("title" => "Report Settings", "mapping" => "index.php:", "url" => "report_settings.php", "level" => "1");
    return $nav;
}

function cactireports_version () {
        return array( 'name'    => 'cactireports',
                        'version'       => '0.0.2',
                        'longname'      => 'Reports',
                        'author'        => 'Bradley Kite',
                        'homepage'      => 'http://www.kitefamily.co.uk',
                        'email' 	=> 'bradley@kitefamily.co.uk',
                        'url'           => 'http://www.kitefamily.co.uk/projects/cactireports/'
                        );
}

function cactireports_show_tab () {
        global $config, $user_auth_realms, $user_auth_realm_filenames;
        $realm_id2 = 0;

        if (isset($user_auth_realm_filenames{basename('report_view.php')})) {
                $realm_id2 = $user_auth_realm_filenames{basename('report_view.php')};
        }
        if ((db_fetch_assoc("select user_auth_realm.realm_id
                from user_auth_realm where user_auth_realm.user_id='" . $_SESSION["sess_user_id"] . "'
                and user_auth_realm.realm_id='$realm_id2'")) || (empty($realm_id2))) {

                print '<a href="' . $config['url_path'] . 'plugins/cactireports/report_view.php"><img src="' . $config['url_path'] . 'plugins/cactireports/images/tab_reports.gif" alt="Reports" align="absmiddle" border="0"></a>';
        }
        cactireports_setup_table();
}

function cactireports_setup_table () {
        global $config, $database_default;
        include_once($config["library_path"] . "/database.php");
        $sql = "show tables from " . $database_default;

        $result = db_fetch_assoc($sql) or die (mysql_error());

        $tables = array();
        $sql = array();

        foreach($result as $index => $arr) {
                foreach ($arr as $t) {
                        $tables[] = $t;
                }
        }

        if (!in_array('plugin_cactireport_definitions', $tables)) {
                $sql[] = "CREATE TABLE plugin_cactireport_definitions (
                            id int NOT NULL AUTO_INCREMENT PRIMARY KEY,
                            report_name varchar(255),
                            data_template_id int,
                            graph_template_id int,
                            rra_id int,
                            include_data_from_start_hour int,
                            include_data_from_end_hour int,
                            include_data_from_start_day int,
                            include_data_from_end_day int,
                            KEY rra_id (rra_id)
                           ) TYPE=MyISAM;";
                $sql[] = "INSERT INTO `user_auth_realm` VALUES (70, 1);";
        }

        if (!in_array('plugin_cactireports', $tables)) {
                $sql[] = "CREATE TABLE plugin_cactireports (
                            id int NOT NULL AUTO_INCREMENT PRIMARY KEY,
                            report_definition_id int not null,
                            date_processed int not null,
                            KEY report_definition_id (report_definition_id)
                          ) TYPE=MyISAM;";
                $sql[] = "INSERT INTO `user_auth_realm` VALUES (71, 1);";
        }

        if (!in_array('plugin_cactireport_items', $tables)) {
                $sql[] = "CREATE TABLE plugin_cactireport_items (
                            id int NOT NULL AUTO_INCREMENT PRIMARY KEY,
                            report_id int NOT NULL,
                            local_graph_id int not null,
                            graph_item_id int not null,
                            graph_item_min_value double,
                            graph_item_avg_value double,
                            graph_item_max_value double,
                            KEY report_id (report_id)
                ) TYPE=MyISAM;";
        }

        if (!in_array('plugin_cactireport_last_values', $tables)) {
            $sql[] = "CREATE TABLE plugin_cactireport_last_values (
                          id int NOT NULL AUTO_INCREMENT PRIMARY KEY,
                          report_definition_id int not null,
                          local_graph_id int not null,
                          graph_item_id int not null,
                          graph_item_last_value double,
                          key report_def_id (report_definition_id)
                        ) TYPE=MyISAM;";
        }

        if (!empty($sql)) {
                for ($a = 0; $a < count($sql); $a++) {
                        $result = mysql_query($sql[$a]);
                }
        }

        $sql = "show columns from plugin_cactireport_items from " . $database_default;
        $result = mysql_query($sql) or die (mysql_error());
        $found = false;
        while ($row = mysql_fetch_array($result, MYSQL_ASSOC)) {
                if ($row['Field'] == 'graph_item_id')
                        $found = true;
        }
        if (!$found) {
                $sql = "ALTER TABLE plugin_cactireport_items ADD graph_item_id int NOT NULL after local_graph_id";
                $result = mysql_query($sql) or die (mysql_error());
                $sql = "ALTER TABLE plugin_cactireport_items ADD graph_item_min_value double DEFAULT 0.0 after graph_item_value";
                $result = mysql_query($sql) or die (mysql_error());
                $sql = "ALTER TABLE plugin_cactireport_items ADD graph_item_avg_value double DEFAULT 0.0 after graph_item_min_value";
                $result = mysql_query($sql) or die (mysql_error());
                $sql = "ALTER TABLE plugin_cactireport_items ADD graph_item_max_value double DEFAULT 0.0 after graph_item_avg_value";
                $result = mysql_query($sql) or die (mysql_error());

                $sql = "UPDATE plugin_cactireport_items SET graph_item_avg_value = graph_item_value";
                $result = mysql_query($sql) or die (mysql_error());

                $sql = "SELECT id, local_graph_id, consolidation_function_id, graph_item_name FROM plugin_cactireport_items";
                $result = mysql_query($sql) or die (mysql_error());
                while ($row = mysql_fetch_array($result, MYSQL_ASSOC))
                {
                    $sql = "SELECT local_graph_template_item_id FROM graph_templates_item WHERE local_graph_id = " . $row['local_graph_id'] . " AND consolidation_function_id = " . $row['consolidation_function_id'] . " AND text_format = '" . $row['graph_item_name'] . "'";
                    $getIdResult = mysql_query($sql) or die (mysql_error());
                    if (mysql_num_rows($getIdResult) == 1)
                    {
                        $IDRow = mysql_fetch_array($getIdResult, MYSQL_ASSOC);
                        $sql = "UPDATE plugin_cactireport_items SET graph_item_id = " . $IDRow['local_graph_template_item_id'] . " WHERE id = " . $row['id'];
                        $updateResult = mysql_query($sql);
                    }
                    /* there's no other way to map names to ID's - just ignore them */
                }

                $sql = "ALTER TABLE plugin_cactireport_items DROP consolidation_function_id";
                $result = mysql_query($sql) or die (mysql_error());
                $sql = "ALTER TABLE plugin_cactireport_items DROP graph_item_name";
                $result = mysql_query($sql) or die (mysql_error());
                $sql = "ALTER TABLE plugin_cactireport_items DROP graph_item_units";
                $result = mysql_query($sql) or die (mysql_error());
                $sql = "ALTER TABLE plugin_cactireport_items DROP graph_item_value";
                $result = mysql_query($sql) or die (mysql_error());

#                $sql = "ALTER TABLE plugin_cactireport_definitions ADD enabled enum('on', 'off') NOT NULL DEFAULT 'on'";
#                $result = mysql_query($sql) or die (mysql_error());
        }

        $sql = "show columns from plugin_cactireport_definitions from " . $database_default;
        $result = mysql_query($sql) or die (mysql_error());
        $found = false;
        while ($row = mysql_fetch_array($result, MYSQL_ASSOC)) {
                if ($row['Field'] == 'enabled')
                        $found = true;
        }
        if (!$found) {
                $sql = "ALTER TABLE plugin_cactireport_definitions ADD enabled enum('on', 'off') NOT NULL DEFAULT 'on'";
                $result = mysql_query($sql) or die (mysql_error());
	}
}

function cactireports_config_arrays () {
        global $user_auth_realms, $user_auth_realm_filenames, $menu;

        $user_auth_realm_filenames['report_settings.php'] = 70;
        $user_auth_realm_filenames['report_view.php']     = 71;
        $user_auth_realms[70]                             = 'Configure Reports';
        $user_auth_realms[71]                             = 'View Reports';

        $temp = $menu['Utilities'];
        unset($menu['Utilities']);
        $menu["Cacti Reports"]['plugins/cactireports/report_settings.php'] = "Report Settings";
        $menu['Utilities'] = $temp;
}

function cactireports_config_form()
{
    global $struct_report_definition;

    $hoursOfTheDay = array (
    "0" => "00:00",
    "1" => "01:00",
    "2" => "02:00",
    "3" => "03:00",
    "4" => "04:00",
    "5" => "05:00",
    "6" => "06:00",
    "7" => "07:00",
    "8" => "08:00",
    "9" => "09:00",
    "10" => "10:00",
    "11" => "11:00",
    "12" => "12:00",
    "13" => "13:00",
    "14" => "14:00",
    "15" => "15:00",
    "16" => "16:00",
    "17" => "17:00",
    "18" => "18:00",
    "19" => "19:00",
    "20" => "20:00",
    "21" => "21:00",
    "22" => "22:00",
    "23" => "23:00");

    $daysOfTheWeek = array(
    "0" => "Monday",
    "1" => "Tuesday",
    "2" => "Wednesday",
    "3" => "Thursday",
    "4" => "Friday",
    "5" => "Saturday",
    "6" => "Sunday"
    );

    $struct_report_definition = array(
        "id" => array(
                "method" => "hidden_zero",
                "value" => "|arg1:id|"),
        "report_name" => array(
                "friendly_name" => "Report Name",
                "method" => "textbox",
                "max_length" => "250",
                "default" => "",
                "description" => "Choose a name for this report.",
                "flags" => ""),
        "data_template_id" => array(
                "method" => "drop_sql",
                "friendly_name" => "Data Template",
                "description" => "Report on items based on this Data Template",
                "sql" => "select id, name from data_template ORDER BY name",
                "default" => "",
                "none_value" => "Select One",
                "flags" => ""
                ),
        "graph_template_id" => array(
                "method" => "drop_sql",
                "friendly_name" => "Graph Template",
                "description" => "Report on items based on this Graph Template",
                "sql" => "select id ,name from graph_templates ORDER BY name",
                "default" => "",
                "none_value" => "Select One",
                "flags" => ""
                ),
        "rra_id" => array(
                "method" => "drop_sql",
                "friendly_name" => "RRA",
                "description" => "Which RRA's to use when creating the report.",
                "sql" => "select id, name from rra ORDER BY timespan",
                "default" => "",
                "none_value" => "Select One",
                "flags" => ""
                ),
        "include_data_from_start_hour" => array(
                "method" => "drop_array",
                "friendly_name" => "Start Hour",
                "description" => "Only use data after this hour each day",
                "array" => $hoursOfTheDay,
                "default" => "0"
                ),
        "include_data_from_end_hour" => array(
                "method" => "drop_array",
                "friendly_name" => "End Hour",
                "description" => "Only use data before this hour each day",
                "array" => $hoursOfTheDay,
                "default" => "23"
                ),
        "include_data_from_start_day" => array(
                "method" => "drop_array",
                "friendly_name" => "Start Day",
                "description" => "Only use data after this day each week",
                "array" => $daysOfTheWeek,
                "default" => "0"
                ),
        "include_data_from_end_day" => array(
                "method" => "drop_array",
                "friendly_name" => "End Day",
                "description" => "Only use data before this day each week",
                "array" => $daysOfTheWeek,
                "default" => "6"
                ),
);

}

function cactireports_update_current_values()
{
    global $config;
    $p = dirname(__FILE__);
    $command_string = $p . "/runReports.pl 0";
    print "HOORRAAAYYYYYYY\n";
    exec_background("/usr/bin/perl", $command_string);
}

?>
